<template>
  <div class="loading" v-show="loading">
    <div class="loading-bar rainbow"></div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from 'vue';

export default defineComponent({
  name: 'bar-loader',
  props: {
    loading: { type: Boolean, required: true },
  },
});
</script>

<style lang="scss" scoped>
.loading {
    position: absolute;
    z-index: 999;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    overflow: visible;
    margin: auto;
    top: 0;
    left: 0;
    bottom: 0;
    right: 0;

    &:before {
        content: '';
        display: block;
        position: absolute;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
        background-color: rgba(#FFFFFF, 0.6);
    }

    .loading-bar {
        position: relative;
        height: 4px;
        display: block;
        width: 100%;
        background-clip: padding-box;
        overflow: hidden;

        &.solid {
            background-color: blue;

            &:before, &:after {
                content: '';
                background-color: #ffffff;
                position: absolute;
                top: 0;
                bottom: 0;
                left: 0;
                will-change: left,right;
                animation: solidRandomLoadingBar 2.1s cubic-bezier(.65, .815, .735, .395) infinite;
            }

            &:after {
                animation: solidRandomLoadingBar 2.1s cubic-bezier(.165, .84, .44, 1) infinite;
                animation-delay: 1.15s
            }
        }

        &.rainbow {
            background: linear-gradient(90deg, red 0%, yellow 15%, lime 30%, cyan 50%, blue 65%, magenta 80%, red 100%);
            animation: moveGradient 3.5s linear infinite;
            height: 4px;
            width: 100%;
            opacity: 0.5;
            background-size: 200%;
        }
    }
}

@keyframes solidRandomLoadingBar {
    0% { left: -35%; right: 100% }
    100%,60% { left: 100%; right: -90% }
}

@keyframes solidRandomLoadingBarShort {
    0% { left: -200%; right: 100% }
    100%,60% { left: 107%; right: -8% }
}

@keyframes moveGradient {
  0% { background-position: 0% 0% }
  100% { background-position: -200% 0% }
}
</style>